#2439 closed defect (fixed)

GCC 4.9.3 ARM build fails on OS X 10.11 (El Capitan)

Reported by: Chris Johns Owned by: Chris Johns
Priority: normal Milestone: 4.11.3
Component: tool/gcc Version: 4.11
Severity: normal Keywords:
Cc: Blocked By:
Blocking: #3262

Description

Building 4.11/rtems-arm with the RSB fails with (error report attached):

/Users/chris/development/rtems/rsb/rtems-source-builder/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin15.0.0-1/build/./gcc/xgcc -B/Users/chris/development/rtems/rsb/rtems-source-builder/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin15.0.0-1/build/./gcc/ -nostdinc -B/Users/chris/development/rtems/rsb/rtems-source-builder/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin15.0.0-1/build/arm-rtems4.11/newlib/ -isystem /Users/chris/development/rtems/rsb/rtems-source-builder/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin15.0.0-1/build/arm-rtems4.11/newlib/targ-include -isystem /Users/chris/development/rtems/rsb/rtems-source-builder/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin15.0.0-1/gcc-4.9.3/newlib/libc/include -B/Users/chris/development/rtems/4.11/arm-rtems4.11/bin/ -B/Users/chris/development/rtems/4.11/arm-rtems4.11/lib/ -isystem /Users/chris/development/rtems/4.11/arm-rtems4.11/include -isystem /Users/chris/development/rtems/4.11/arm-rtems4.11/sys-include    -g -O2 -mthumb -O2 -I../../../../gcc-4.9.3/libgcc/../newlib/libc/sys/rtems/include -g -O2 -DIN_GCC  -DCROSS_DIRECTORY_STRUCTURE  -W -Wall -Wno-narrowing -Wwrite-strings -Wcast-qual -Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition  -isystem ./include   -fno-inline -g -DIN_LIBGCC2 -fbuilding-libgcc -fno-stack-protector -Dinhibit_libc  -fno-inline -I. -I. -I../../.././gcc -I../../../../gcc-4.9.3/libgcc -I../../../../gcc-4.9.3/libgcc/. -I../../../../gcc-4.9.3/libgcc/../gcc -I../../../../gcc-4.9.3/libgcc/../include  -DHAVE_CC_TLS  -o _arm_unorddf2_s.o -MT _arm_unorddf2_s.o -MD -MP -MF _arm_unorddf2_s.dep -DSHARED -DL_arm_unorddf2 -xassembler-with-cpp -c ../../../../gcc-4.9.3/libgcc/config/arm/lib1funcs.S
../../../../gcc-4.9.3/libgcc/config/arm/ieee754-df.S: Assembler messages:
../../../../gcc-4.9.3/libgcc/config/arm/ieee754-df.S:567: Error: invalid constant (ff) after fixup
../../../../gcc-4.9.3/libgcc/config/arm/ieee754-df.S:673: Error: invalid constant (ff) after fixup
../../../../gcc-4.9.3/libgcc/config/arm/ieee754-df.S:689: Error: invalid constant (fd) after fixup
../../../../gcc-4.9.3/libgcc/config/arm/ieee754-df.S:875: Error: invalid constant (ff) after fixup
../../../../gcc-4.9.3/libgcc/config/arm/ieee754-df.S:912: Error: invalid constant (fd) after fixup
../../../../gcc-4.9.3/libgcc/config/arm/ieee754-df.S:985: Error: invalid constant (fd) after fixup

Attachments (2)

rsb-report-arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin15.0.0-1.txt (95.3 KB) - added by Chris Johns on Nov 2, 2015 at 12:05:09 AM.
RSB report.
gcc-4.9.3-macos-xcode9.diff (3.6 KB) - added by Chris Johns on Jan 23, 2018 at 10:09:36 PM.
Fixes for MacOS (High Sierra) and Xocde 9.2 command line tools.

Download all attachments as: .zip

Change History (14)

comment:1 Changed on Nov 2, 2015 at 12:06:00 AM by Chris Johns

Summary: ARM build fails on OS X 10.11 (Ll Capitan)GCC 4.9.3 ARM build fails on OS X 10.11 (Ll Capitan)

comment:2 Changed on Nov 2, 2015 at 2:47:10 AM by Amar Takhar

Summary: GCC 4.9.3 ARM build fails on OS X 10.11 (Ll Capitan)GCC 4.9.3 ARM build fails on OS X 10.11 (El Capitan)

comment:3 Changed on Nov 4, 2015 at 11:31:42 PM by Chris Johns

The ARM target does not build on Yosemite or El Capitan with Xcode 7.1 command line tools and the problem still exists in El Capitan with Xcode 7.1 and the 7.2 beta command line tools.

It appears to be a bug in clang in Xcode building tc-arm.c in binutils. I have raise a bug report with Apple with a small test case.

comment:4 Changed on Nov 5, 2015 at 12:59:15 AM by Joel Sherrill

Did you ask about this on the binutils and clang lists? It might actually get more traction on the public side.

comment:5 Changed on Nov 11, 2015 at 12:11:22 AM by Chris Johns

I raised a bug report and it has been fixed in binutils and should be released in 2.26.

comment:6 Changed on Jan 26, 2017 at 7:16:00 AM by Sebastian Huber

Milestone: 4.11.14.11.2

comment:7 Changed on Mar 23, 2017 at 1:04:45 AM by Chris Johns

Milestone: 4.11.24.11.3

The 4.11.2 milestone is closing.

comment:8 Changed on Oct 10, 2017 at 5:58:26 AM by Sebastian Huber

Component: GCCtool/gcc

comment:9 Changed on Jan 23, 2018 at 3:03:54 AM by Chris Johns

Blocking: 3262 added

comment:10 Changed on Jan 23, 2018 at 5:10:15 AM by Chris Johns

Testing the latest RSB for this ticket with the latest MacOS (High Sierra) with the latest Xcode (9.2) and it's command line tools fails with:

/usr/bin/c++ -O2 -pipe -fbracket-depth=1024 -I/opt/work/chris/rtems/rsb/rtems-source-builder.git/rtems/build/tmp/sb-chris/4.11/rtems-arm.bset/opt/work/rtems/4.11/include -c  -DIN_GCC_FRONTEND -g -O2 -DIN_GCC  -DCROSS_DIRECTORY_STRUCTURE  -fno-exceptions -fno-rtti -fasynchronous-unwind-tables -W -Wall -Wno-narrowing -Wwrite-strings -Wcast-qual -Wmissing-format-attribute -pedantic -Wno-long-long -Wno-variadic-m
acros -Wno-overlength-strings   -DHAVE_CONFIG_H -I. -Ic -I../../gcc-4.9.3/gcc -I../../gcc-4.9.3/gcc/c -I../../gcc-4.9.3/gcc/../include -I../../gcc-4.9.3/gcc/../libcpp/include -I/opt/work/chris/rtems/rsb/rtems-source-builder.git/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin17.3.0-1/build/./gmp -I/opt/work/chris/rtems/rsb/rtems-source-builder.git/rtems/build/arm-rtems4.11-gcc-4.9
.3-newlib-2.2.0.20150423-x86_64-apple-darwin17.3.0-1/gcc-4.9.3/gmp -I/opt/work/chris/rtems/rsb/rtems-source-builder.git/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin17.3.0-1/build/./mpfr -I/opt/work/chris/rtems/rsb/rtems-source-builder.git/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin17.3.0-1/gcc-4.9.3/mpfr -I/opt/work/chris/rtems/rsb/rtems-sourc
e-builder.git/rtems/build/arm-rtems4.11-gcc-4.9.3-newlib-2.2.0.20150423-x86_64-apple-darwin17.3.0-1/gcc-4.9.3/mpc/src  -I../../gcc-4.9.3/gcc/../libdecnumber -I../../gcc-4.9.3/gcc/../libdecnumber/dpd -I../libdecnumber -I../../gcc-4.9.3/gcc/../libbacktrace    -o c/c-objc-common.o -MT c/c-objc-common.o -MMD -MP -MF c/.deps/c-objc-common.TPo ../../gcc-4.9.3/gcc/c/c-objc-common.c
clang: warning: treating 'c' input as 'c++' when in C++ mode, this behavior is deprecated [-Wdeprecated]
In file included from ../../gcc-4.9.3/gcc/c/c-objc-common.c:33:
In file included from /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/new:89:
/Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/exception:173:5: error: no member named 'fancy_abort' in namespace 'std::__1'; did you mean simply 'fancy_abort'?
    _VSTD::abort();
    ^~~~~~~
/Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/__config:392:15: note: expanded from macro '_VSTD'
#define _VSTD std::_LIBCPP_NAMESPACE
              ^
../../gcc-4.9.3/gcc/system.h:685:13: note: 'fancy_abort' declared here
extern void fancy_abort (const char *, int, const char *) ATTRIBUTE_NORETURN;
            ^
1 error generated.

Changed on Jan 23, 2018 at 10:09:36 PM by Chris Johns

Attachment: gcc-4.9.3-macos-xcode9.diff added

Fixes for MacOS (High Sierra) and Xocde 9.2 command line tools.

comment:11 Changed on Jan 25, 2018 at 5:51:43 AM by Chris Johns

Owner: set to Chris Johns
Status: newaccepted

comment:12 Changed on Feb 7, 2018 at 5:12:32 AM by Chris Johns

Resolution: fixed
Status: acceptedclosed
Note: See TracTickets for help on using tickets.